#include <stdlib.h>
#include <stdio.h>
#include <vector>

using namespace std;

vector<int> next[50010];
int lnext[50010];
vector<int> wtab[50010];
vector<int> ttab[50010];
vector<int> atab[50010];
vector<int> ltab[50010];
vector<int> aktt[50010];
int TIME;
bool zrobione[50010];

int prev[50010];
int previ[50010];

int n,m;

int Q[50010];
int QV[50010];
int miejsce[50010];
int Qsize;

#define INF 2000000000

void heapUp(int v) {
  int i = miejsce[v];
  while (i>0 && Q[(i-1)/2] > Q[i]) {
    int parent = (i-1)/2;
    int tmp = Q[parent];
    Q[parent] = Q[i];
    Q[i] = tmp;
    tmp = QV[parent];
    QV[parent] = QV[i];
    QV[i] = tmp;
    miejsce[QV[parent]] = parent;
    miejsce[QV[i]] = i;

    i = parent;
  }
}

void heapPop() {
  int n;
  int l,r,i;
  Qsize--;

  int tmpq = Q[0];
  int tmpqv = QV[0];

  Q[0] = Q[Qsize];
  QV[0] = QV[Qsize];
  miejsce[QV[0]] = 0;


  i = 0;
  while (true) {
    l = 2*i+1;
    r = 2*i + 2;
    if (l < Qsize && Q[l] < Q[i])
      n = l;
    else n = i;
    if (r < Qsize && Q[r] < Q[n])
      n = r;
    if (n==i) break;


    int tmp = Q[n];
    Q[n] = Q[i];
    Q[i] = tmp;
    tmp = QV[n];
    QV[n] = QV[i];
    QV[i] = tmp;
    miejsce[QV[n]] = n;
    miejsce[QV[i]] = i;

    i = n;

  }

  Q[Qsize] = tmpq;
  QV[Qsize] = tmpqv;
  miejsce[tmpqv] = Qsize;
}

void go() {

  //  n = 30;

  for (int i=0; i < n; i++) {
    Q[i] = INF;
    QV[i] = i;
    miejsce[i] = i;
  }
  Qsize = n;
  Q[0] = 0;
  while (Qsize > 0) {
    int t = Q[0];
    int v = QV[0];
    int u;
    int t2;

    zrobione[v] = true;

    //    printf(":: %d %d\n", t, v);
    if (t == INF)
      break;

    if (v == n-1) {
      TIME = t;
      
      if (v > 1) {
	int iok;

	while(prev[v] > 0) {
	  iok = previ[v];
	  v = prev[v];
	}
	int zwloka = 0;

	int najpozniej = Q[miejsce[v]];

	int t2 = 0;
	if (ttab[v][iok] > 0) {
	  if (najpozniej < atab[v][iok])
	    t2 = atab[v][iok] - najpozniej;
	  else {
	    int h=(najpozniej-atab[v][iok])%ttab[v][iok];
	    if (h >= ltab[v][iok])
	      t2 = ttab[v][iok] - h;
	  }

	}
	najpozniej += t2;

	for (int i=lnext[0]-1; i>=0; i--) {
	  int u = next[0][i];
	  if (u != v) continue;
	  if (atab[0][i] + wtab[0][i] <= najpozniej)
	    zwloka >?= atab[0][i];
	}

	TIME -= zwloka;
      }
    



      break;
    }


    heapPop();

    for (int i = lnext[v]-1; i >=0 ; i--) {
      u = next[v][i];
      if (zrobione[u]) continue;
      t2 = t + wtab[v][i];
      if (ttab[v][i] > 0) {
	if (t < atab[v][i])
	  t2 += atab[v][i] - t;
	else {
	  int h=(t-atab[v][i])%ttab[v][i];
	  if (h >= ltab[v][i])
	    t2 += ttab[v][i] - h;
	}

	/*if (tp >= atab[v][i] + ltab[v][i])
	  t2 += atab[v][i] + ttab[v][i] - tp;*/
      }
      //      printf("! %d\n", t2);
      if (Q[miejsce[u]] > t2) {
	prev[u] = v;
	previ[u] = i;
	Q[miejsce[u]] = t2;
	heapUp(u);
      }
    }
    
  }

}

int main() {
  int d,w,t,a,l;
  scanf("%d", &d);

  while (d--) {
    scanf("%d%d", &n, &m);
    
    for (int i=0;i<n;i++) {
      lnext[i] = 0;
      zrobione[i] = false;
    }
    for (int i=0; i<m; i++) {
      int u,v;
      scanf("%d%d%d%d%d%d", &u, &v, &w, &t, &a, &l);
      u--;
      v--;
      next[u].push_back(v);
      lnext[u]++;

      wtab[u].push_back(w);
      ttab[u].push_back(t);
      atab[u].push_back(a);
      ltab[u].push_back(l);
    }
    TIME = -1;
    go();
    if (TIME == -1)
      printf("NIE\n");
    else
      printf("%d\n", TIME);

    for (int i=0;i<n;i++) {
      next[i].clear();
      wtab[i].clear();
      ttab[i].clear();
      atab[i].clear();
      ltab[i].clear();
    }
	       
  }
  return 0;
}
